
package org.mule.modules.twiml.config.spring;

import org.springframework.beans.factory.xml.NamespaceHandlerSupport;


/**
 * Registers bean definitions parsers for handling elements in <code>http://www.mulesoft.org/schema/mule/twiml</code>.
 * 
 */
public class TwiMLModuleNamespaceHandler
    extends NamespaceHandlerSupport
{


    /**
     * Invoked by the {@link DefaultBeanDefinitionDocumentReader} after construction but before any custom elements are parsed. 
     * @see NamespaceHandlerSupport#registerBeanDefinitionParser(String, BeanDefinitionParser)
     * 
     */
    public void init() {
        registerBeanDefinitionParser("config", new TwiMLModuleConfigDefinitionParser());
        registerBeanDefinitionParser("response", new ResponseDefinitionParser());
        registerBeanDefinitionParser("say", new SayDefinitionParser());
        registerBeanDefinitionParser("play", new PlayDefinitionParser());
        registerBeanDefinitionParser("gather", new GatherDefinitionParser());
        registerBeanDefinitionParser("record", new RecordDefinitionParser());
        registerBeanDefinitionParser("sms", new SmsDefinitionParser());
        registerBeanDefinitionParser("dial", new DialDefinitionParser());
    }

}
